#include "WorkerServiceCheck.h"

#include "ProcessConfig.h"
#include "Logger.h"
#include "FhsShm.h"
#include "ServiceCheck.h"

#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <time.h>



// 서비스 Check 주기 (sec)
#define SERVICE_CHECK_INTERVAL     4


// 공유메모리에 Data Set, Get 을 담당할 객체에 대한 포인터.
// Main 프로세스에서 생성 처리하며... 전역변수로 설정되어 있다.
extern CFhsShm * g_pFhsShm;


// Worker::ServiceCheck 프로세스의 Main 역활을 수행하기 위한 함수.
int WorkerServiceCheckMain()
{
	setproctitle( "ServiceCheck [initialize]" );

	// Set Signal Handler
	SetWorkerServiceCheckSignalHandler();
	

	// Main Process 에서 생성한 공유메모리 접근 객체 유효성 확인
	// NULL 인 경우... 초기화 실패로 처리한다.
	if( g_pFhsShm == NULL )
	{
		// 객체 생성 실패시
		LOG( LERR, "[ServiceCheck:%d] Shared memory object not valid. process exit", getpid() );

		ReadyToExitWorkerServiceCheck();
		return EXIT_FAILURE;
	}

	// Service 상태 Check를 담당할 객체 생성 및 초기화.
	CServiceCheck serviceCheck( g_pFhsShm );
	if( serviceCheck.Init( CProcessConfig::GetInstance()->GetSvcNic()
		                 , CProcessConfig::GetInstance()->GetCheckDns()
						 , CProcessConfig::GetInstance()->GetFimngdCheckPort() ) == false )
	{
		// 객체 초기화 실패시
		LOG( LERR, "[ServiceCheck:%d] service check module init fail. process exit", getpid() );

		ReadyToExitWorkerServiceCheck();
		return EXIT_FAILURE;
	}
	
	// 전체 프로세스의 생성이 완료될때까지 대기 후 작업 시작
	sleep( 1 );
	setproctitle( "ServiceCheck" );


	// 최초 기동시 서비스 상태는 수동 중지(1) 상태로 설정한다.
	// - Main 프로세스에서 공유메모리 초기화 작업시 처리함.
	// g_pFhsShm->SetServiceStat( SERVICE_STAT_OUT );
	

	// 주기적으로 Service 상태를 점검 처리한다.
	while( 1 )
	{

		// Service Check Start time 정보를 공유 메모리에 업데이트 (#31701)
		// - Check 시 Hang 발생을 탐지할 수 있도록 expire 처리를 위한 시간값 업데이트 기능 추가
		g_pFhsShm->UpdateTimeServiceCheck();

		// Service 상태 Check 수행.
		serviceCheck.Check();


		// 지정된 시간동안 sleep
		sleep( SERVICE_CHECK_INTERVAL );
	}
	
	// 종료시 정리 작업 수행
	ReadyToExitWorkerServiceCheck();
	return EXIT_SUCCESS;
}

// 프로세스 종료 전 처리할 종료 관련 각 작업을 일괄로 처리하기 위한 함수.
void ReadyToExitWorkerServiceCheck()
{
	// Logger 객체 종료 처리.
	CLogger::Exit();

	return;
}

// Worker ServiceCheck 프로세스에 대한 대한 종료 처리 수신시.
static void SignalWorkerServiceCheckTerminate( int nSignalNumber )
{
	// Signal Number 에 따른 로깅처리.
	if( nSignalNumber == SIGTERM )
	{
		_LOG( LINF, "[ServiceCheck:%d] Process exit by SIGTERM signal. Good Bye..", getpid() );
	}
	else
	{
		_LOG( LWAR, "[ServiceCheck:%d] Process exit by abnormal signal[%d], Good Bye..", getpid(), nSignalNumber );
	}

	ReadyToExitWorkerServiceCheck();

	// 종료전 잠시 대기
	struct timespec sleep;
	sleep.tv_sec = 0;
	sleep.tv_nsec = 500000000;  // 0.5 sec
	nanosleep( &sleep, NULL );

	exit( EXIT_SUCCESS );
}

// Worker::ServiceCheck Process 의 signal 처리기...
void SetWorkerServiceCheckSignalHandler()
{
	sigset_t set;
	struct sigaction act;

	memset( &act, 0x00, sizeof( act ) );
	sigfillset( &set );
	sigprocmask( SIG_SETMASK, &set, NULL );
	sigfillset( &act.sa_mask );

	// 무시 처리 signal
	act.sa_handler = SIG_IGN;
	sigaction( SIGPIPE, &act, NULL );	/* desciptor 오류 발생시 Process가 죽는 것은 방지하기 위하여 설정 */
	sigaction( SIGHUP, &act, NULL );	/* process를 기동시킨 관리자의 로그아웃시, 또는 config reload 등의 처리 signal*/
	sigaction( SIGINT, &act, NULL );	/* ^C 키를 누른 경우 받는 신호 => demon 으로 기동되기 땜시 이 신호 못받음 */
	sigaction( SIGQUIT, &act, NULL );	/* 키보드에 의한  Abort 신호 처리 => ? */

	// Worker 프로세스는 자식 프로세스가 존재하지 않으므로 그냥 무시처리함.
	act.sa_handler = SIG_IGN;
	sigaction( SIGCHLD, &act, NULL );

	/* 각종 에러나 사용자의 종료 신호 처리 */
	act.sa_handler = SignalWorkerServiceCheckTerminate;
	sigaction( SIGTERM, &act, NULL );	/* kill -TERM 에 의한 프로세스 종료시 */

	// 나머지 신호는 default 처리.

	sigemptyset( &set );                  /* 신호 처리기 처리 설정 위한 블록 해제 */
	sigprocmask( SIG_SETMASK, &set, NULL );
}
